@use crate::home_page::HomePage;
@use crate::home_page::Recents;
@use crate::Urler;

@(home: &HomePage<'_>, url: &Urler, recents: Recents<'_>)

<feed xmlns="http://www.w3.org/2005/Atom">
    <title>Lib.rs</title>
    <subtitle>Recently published Rust libraries and applications</subtitle>
    <link href="https://lib.rs"/>
    <link rel="self" href="https://lib.rs/atom.xml"/>
    <updated>@home.now()</updated>
    <author>
      <name>lib.rs (@"@"kornelski)</name>
      <uri>https://github.com/kornelski</uri>
    </author>
    <icon>https://lib.rs/crates-logo.png</icon>
    <id>https://crates.rs</id>
    <generator uri="https://gitlab.com/crates.rs">lib.rs</generator>

    @for (all, ver, authors) in recents {
        <entry>
          <title>@ver.capitalized_name() (@ver.version())</title>
          <link href="https://lib.rs@url.krate(ver)"/>
          <id>https://crates.rs@url.krate(ver)/@ver.version()</id>
          <updated>@home.last_modified(&all)</updated>
          @if let Some(d) = ver.description() {
              <summary type="text">@d</summary>
          }
          @for slug in ver.category_slugs() {
            <category term="@slug" />
          }
          @if let Some(lic) = ver.license() {
            <rights>@lic</rights>
          }
          @for o in authors.into_iter().take(10) {
            @if o.owner {
              <author><name>@o.name()</name>@if let Some(link) = url.author(o) {<uri>@link</uri>}</author>
            } else {
              <contributor><name>@o.name()</name>@if let Some(link) = url.author(o) {<uri>@link</uri>}</contributor>
            }
          }
        </entry>
    }
</feed>
